// Copyright 1998-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import <OmniSCSI/OSCSIBlockUnit.h>

#import <OmniSCSI/OSCSIGeneric.h>
#import <OmniSCSI/OSCSIResponse.h>

@implementation OSCSIBlockUnit

- (OSCSIResponse *) startStopUnit: (BOOL) start;
{
    OSCSIResponse             *response;
    unsigned char              command;

    // In SCSI-2 this byte contains the eject/don't eject flag and the start/stop
    // flag.  We don't want to eject (we have another command for that).
    // Under SCSI-3, the portions reserved in SCSI-2 are dedicated to pwoer control.
    // The value of zero indicates that the power usage should remain the same.
    command = (start) ? 1 : 0;

    OBASSERT(_generic);
    response = [_generic newResponseByWritingData: nil
                                           opcode: 0x1B      // START/STOP UNIT
                                             name: "START/STOP UNIT"
                                             arg1: 0x0       // RESERVED/IMMED
                                             arg2: 0x0       // RESERVED
                                             arg3: 0x0       // RESERVED
                                             arg4: command]; // as above

    if ([response isError])
        NSLog(@"Error in stopPlaying - %@", [response errorString]);

    return [response autorelease];
}


@end
