// Copyright 1998-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/./Frameworks/OmniSCSI/OSCSIBus.h,v 1.9 2000/09/08 19:18:34 bungi Exp $

#import <OmniFoundation/OmniFoundation.h>

#import <OmniSCSI/OSCSIUnitDescription.h>

@class OSCSITarget;

typedef unsigned int OSCSIBusNumberType;

// If this is used when initializing the OSCSITarget, it will only
// use the raw device (instead of the generic device).  This is
// useful when you don't want to scan the bus to find the SCSI
// target or when the device is an ATAPI device (and doesn't have
// a bus/target/unit).
#define OSCSI_INVALID_BUS_NUMBER ((OSCSIBusNumberType)-1)

@interface OSCSIBus : OFObject
{
    OSCSIBusNumberType  _busNumber;
    NSArray            *_targets;
}

+ (NSArray *) busses;
+ (OSCSIBus *) busWithBusNumber: (OSCSIBusNumberType) busNumber;

- (OSCSIBusNumberType) busNumber;

- (NSArray *) targets;
- (OSCSITarget *) targetWithTargetNumber: (unsigned int) target;
- (OSCSITarget *) targetWithRawDeviceName: (NSString *) deviceName;

- (NSArray *) allUnitsWithPeripheralType: (OSCSIPeripheralType) peripheralType;

- (void) reset;

@end
