// Copyright 1998-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/./Frameworks/OmniSCSI/OSCSICDAudioStream.h,v 1.4 2000/09/08 19:18:34 bungi Exp $

#import <OmniFoundation/OmniFoundation.h>
#import <OmniSCSI/OSCSICDProtocols.h>

OmniSCSI_EXTERN NSString *OSCSICDAudioStreamInterruptedException;

@interface OSCSICDAudioStream : OFObject
{
    NSObject <OSCSICDRomAudioData> *_audioSource;
    OSCSILogicalBlockAddress        _startingLBA;
    OSCSILogicalBlockAddress        _endingLBA;
    OSCSILogicalBlockAddress        _blocksPerTransfer;
    
    OFQueue                        *_bufferQueue;
    OSCSILogicalBlockAddress        _currentLBA;
}

- initWithAudioSource: (NSObject <OSCSICDRomAudioData> *) audioSource
          startingLBA: (OSCSILogicalBlockAddress) startingLBA
            endingLBA: (OSCSILogicalBlockAddress) endingLBA
    blocksPerTransfer: (OSCSILogicalBlockAddress) blocksPerTransfer;

- (NSData *) nextAudioBlock;

@end
