// Copyright 1998-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/./Frameworks/OmniSCSI/OSCSICDTableOfContents.h,v 1.4 2000/09/08 19:18:35 bungi Exp $

#import <OmniFoundation/OmniFoundation.h>

#import <OmniSCSI/OSCSIUnit.h> // For OSCSILogicalBlockAddress

// This can be used to find the start time of the lead out track,
// that is the time at which the disc ends.
#define OSCSI_LEAD_OUT_TRACK (0xAA)

// This is pretty simplistic right now, but later it will encompass more
// info -- enough to burn CDs.
typedef struct _OSCSICDTableOfContents {
    unsigned int             trackNumber;
    OSCSILogicalBlockAddress startingLBA;
} OSCSICDTableOfContentsEntry;


@interface OSCSICDTableOfContents : OFObject
{
    unsigned int                 _descriptionCount;
    OSCSICDTableOfContentsEntry *_trackDescriptions;
}

- initWithTableOfContentsDescriptions: (OSCSICDTableOfContentsEntry *) descriptions
                                count: (unsigned int) descriptionCount;
// The 'descriptions' must be NSZoneMalloced memory.  The receive owns the
// memory passed to it.  The descriptions must be in ascending order.

- (unsigned int) numberOfTracks;
// Not necessarily the same as _descriptionCount

- (unsigned int) trackContainingLBA: (OSCSILogicalBlockAddress) lba;

- (OSCSILogicalBlockAddress) startingLBAForTrackNumber: (unsigned int) trackNumber;
- (OSCSILogicalBlockAddress) endingLBAForTrackNumber: (unsigned int) trackNumber;

@end
