// Copyright 1998-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/./Frameworks/OmniSCSI/OSCSIResponse.h,v 1.5 2000/09/08 19:18:35 bungi Exp $

#import <OmniFoundation/OmniFoundation.h>

@interface OSCSIResponse : OFObject
{
    unsigned int _statusByte;
    unsigned int _driverStatus;
    
    unsigned int _senseKey;
    unsigned int _additionalSenseCode;
    unsigned int _additionalSenseCodeQualifier;
    int          _bytesNotTransfered;
}

+ (OSCSIResponse *) goodResponse;

- initWithStatusByte: (unsigned int) statusByte
        driverStatus: (unsigned int) driverStatus
            senseKey: (unsigned int) senseKey
 additionalSenseCode: (unsigned int) additionalSenseCode
additionalSenseCodeQualifier: (unsigned int) additionalSenseCodeQualifier
  bytesNotTransfered: (int) bytesNotTransfered;

- (BOOL) isError;

- (unsigned int) statusByte;
- (unsigned int) driverStatus;

- (unsigned int) senseKey;
- (unsigned int) additionalSenseCode;
- (unsigned int) additionalSenseCodeQualifier;

- (int) bytesNotTransfered;

- (NSString *) errorString;

//
// Some special error checks
//
- (BOOL) isMediaMissingError;

@end
