// Copyright 1998-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/./Frameworks/OmniSCSI/OSCSIUnit.h,v 1.12 2000/09/08 19:18:36 bungi Exp $

#ifndef __OSCSIUnit_h
#define __OSCSIUnit_h

#import <OmniFoundation/OmniFoundation.h>

@class OSCSIGeneric, OSCSITarget, OSCSIUnitDescription, OSCSIResponse;

typedef unsigned long long OSCSIUnitNumberType;
typedef unsigned int       OSCSILogicalBlockAddress;

@interface OSCSIUnit : OFObject
{
    OSCSITarget          *_nonretained_target;
    OSCSIUnitNumberType   _unitNumber;

    // This is only non-nil when the instance is 'open'
    OSCSIGeneric         *_generic;

    OSCSIUnitDescription *_unitDescription;
    BOOL                  _mediaPresent;
}

+ (NSArray *) classesForUnitDescription: (OSCSIUnitDescription *) unitDescription;
+ (Class) bestClassForUnitDescription: (OSCSIUnitDescription *) unitDescription;

+ (NSString *) displayName;

- initWithTarget: (OSCSITarget *) target
      unitNumber: (OSCSIUnitNumberType) unitNumber
 unitDescription: (OSCSIUnitDescription *) unitDescription
temporaryGeneric: (OSCSIGeneric *) temporaryGeneric;
// Initializes the receiver.  The temporaryGeneric can be used to read devices speicifc
// identifing information.  For example, this could be used to determine the capabilities
// of the device.  The temporaryGeneric must not be retained.

- (void) open;
- (void) close;
- (BOOL) isOpen;

- (OSCSITarget *) target;
- (OSCSIUnitNumberType) unitNumber;

- (OSCSIUnitDescription *) unitDescription;

- (OSCSIResponse *) testUnitReady;
- (OSCSIResponse *) requestSense;

- (BOOL) mediaIsPresent;
- (void) mediaInserted;
- (void) mediaRemoved;
- (void) setAllowsMediaRemoval: (BOOL) yn;
- (void) requestMedia;
- (void) eject;

@end

#endif
